pull, rebase: simplify to use die()
[git/git.git] / git-rebase.sh
CommitLineData
59e6b23a
JH
1#!/bin/sh
2#
3# Copyright (c) 2005 Junio C Hamano.
4#
5
b2f82e05 6USAGE='[--interactive | -i] [-v] [--force-rebase | -f] [--onto <newbase>] [<upstream>|--root] [<branch>]'
031321c6
SE
7LONG_USAGE='git-rebase replaces <branch> with a new branch of the
8same name. When the --onto option is provided the new branch starts
9out with a HEAD equal to <newbase>, otherwise it is equal to <upstream>
10It then attempts to create a new commit for each commit from the original
11<branch> that does not exist in the <upstream> branch.
69a60af5 12
031321c6
SE
13It is possible that a merge failure will prevent this process from being
14completely automatic. You will have to resolve any such merge failure
cc120056
SE
15and run git rebase --continue. Another option is to bypass the commit
16that caused the merge failure with git rebase --skip. To restore the
51ef1daa
JS
17original <branch> and remove the .git/rebase-apply working files, use the
18command git rebase --abort instead.
69a60af5 19
031321c6 20Note that if <branch> is not specified on the command line, the
702088af 21currently checked out branch is used.
e646c9c8 22
031321c6 23Example: git-rebase master~1 topic
e646c9c8 24
031321c6
SE
25 A---B---C topic A'\''--B'\''--C'\'' topic
26 / --> /
27 D---E---F---G master D---E---F---G master
e646c9c8 28'
533b7039
JH
29
30SUBDIRECTORY_OK=Yes
8f321a39 31OPTIONS_SPEC=
ae2b0f15 32. git-sh-setup
f9474132 33set_reflog_action rebase
7eff28a9 34require_work_tree
533b7039 35cd_to_toplevel
4282c4fb 36
c4427656 37OK_TO_SKIP_PRE_REBASE=
cc120056
SE
38RESOLVEMSG="
39When you have resolved this problem run \"git rebase --continue\".
40If you would prefer to skip this patch, instead run \"git rebase --skip\".
41To restore the original branch and stop rebasing run \"git rebase --abort\".
42"
e646c9c8 43unset newbase
a06f678e 44strategy=recursive
58634dbf 45do_merge=
28ed6e7b 46dotest="$GIT_DIR"/rebase-merge
58634dbf 47prec=4
b758789c 48verbose=
a9c3821c 49diffstat=$(git config --bool rebase.stat)
67dad687 50git_am_opt=
190f5323 51rebase_root=
b2f82e05 52force_rebase=
58634dbf
EW
53
54continue_merge () {
55 test -n "$prev_head" || die "prev_head must be defined"
56 test -d "$dotest" || die "$dotest directory does not exist"
57
5be60078 58 unmerged=$(git ls-files -u)
58634dbf
EW
59 if test -n "$unmerged"
60 then
61 echo "You still have unmerged paths in your index"
9b07873a 62 echo "did you forget to use git add?"
66eb64cb 63 die "$RESOLVEMSG"
58634dbf
EW
64 fi
65
889a50e9 66 cmt=`cat "$dotest/current"`
6848d58c 67 if ! git diff-index --quiet --ignore-submodules HEAD --
58634dbf 68 then
e637122e 69 if ! git commit --no-verify -C "$cmt"
f0ef0596
EW
70 then
71 echo "Commit failed, please do not call \"git commit\""
72 echo "directly, but instead do one of the following: "
73 die "$RESOLVEMSG"
74 fi
7afa845e 75 printf "Committed: %0${prec}d " $msgnum
58634dbf 76 else
7afa845e 77 printf "Already applied: %0${prec}d " $msgnum
58634dbf 78 fi
c7965afd 79 git rev-list --pretty=oneline -1 "$cmt" | sed -e 's/^[^ ]* //'
58634dbf 80
5be60078 81 prev_head=`git rev-parse HEAD^0`
58634dbf 82 # save the resulting commit so we can read-tree on it later
58634dbf
EW
83 echo "$prev_head" > "$dotest/prev_head"
84
85 # onto the next patch:
86 msgnum=$(($msgnum + 1))
5887ac82 87 echo "$msgnum" >"$dotest/msgnum"
58634dbf
EW
88}
89
90call_merge () {
889a50e9 91 cmt="$(cat "$dotest/cmt.$1")"
58634dbf 92 echo "$cmt" > "$dotest/current"
5be60078 93 hd=$(git rev-parse --verify HEAD)
6fd2f5e6 94 cmt_name=$(git symbolic-ref HEAD 2> /dev/null || echo HEAD)
889a50e9
JS
95 msgnum=$(cat "$dotest/msgnum")
96 end=$(cat "$dotest/end")
0bb733c9 97 eval GITHEAD_$cmt='"${cmt_name##refs/heads/}~$(($end - $msgnum))"'
889a50e9 98 eval GITHEAD_$hd='$(cat "$dotest/onto_name")'
0bb733c9
SP
99 export GITHEAD_$cmt GITHEAD_$hd
100 git-merge-$strategy "$cmt^" -- "$hd" "$cmt"
58634dbf
EW
101 rv=$?
102 case "$rv" in
103 0)
0bb733c9 104 unset GITHEAD_$cmt GITHEAD_$hd
9e4bc7dd 105 return
58634dbf
EW
106 ;;
107 1)
b4372ef1 108 git rerere
66eb64cb 109 die "$RESOLVEMSG"
58634dbf
EW
110 ;;
111 2)
112 echo "Strategy: $rv $strategy failed, try another" 1>&2
66eb64cb 113 die "$RESOLVEMSG"
58634dbf
EW
114 ;;
115 *)
116 die "Unknown exit code ($rv) from command:" \
117 "git-merge-$strategy $cmt^ -- HEAD $cmt"
118 ;;
119 esac
120}
121
6fd2f5e6
JS
122move_to_original_branch () {
123 test -z "$head_name" &&
124 head_name="$(cat "$dotest"/head-name)" &&
125 onto="$(cat "$dotest"/onto)" &&
126 orig_head="$(cat "$dotest"/orig-head)"
127 case "$head_name" in
128 refs/*)
129 message="rebase finished: $head_name onto $onto"
130 git update-ref -m "$message" \
131 $head_name $(git rev-parse HEAD) $orig_head &&
132 git symbolic-ref HEAD $head_name ||
133 die "Could not move back to $head_name"
134 ;;
135 esac
136}
137
58634dbf 138finish_rb_merge () {
6fd2f5e6 139 move_to_original_branch
58634dbf
EW
140 rm -r "$dotest"
141 echo "All done."
142}
143
1b1dce4b 144is_interactive () {
f8cca019
AE
145 while test $# != 0
146 do
147 case "$1" in
148 -i|--interactive)
149 interactive_rebase=explicit
150 break
151 ;;
152 -p|--preserve-merges)
153 interactive_rebase=implied
154 ;;
155 esac
1b1dce4b 156 shift
f8cca019
AE
157 done
158
159 if [ "$interactive_rebase" = implied ]; then
160 GIT_EDITOR=:
161 export GIT_EDITOR
162 fi
163
164 test -n "$interactive_rebase" || test -f "$dotest"/interactive
1b1dce4b
JS
165}
166
d70b4a8f 167run_pre_rebase_hook () {
c4427656
NS
168 if test -z "$OK_TO_SKIP_PRE_REBASE" &&
169 test -x "$GIT_DIR/hooks/pre-rebase"
d70b4a8f 170 then
bc2bbc45
SB
171 "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} ||
172 die "The pre-rebase hook refused to rebase."
d70b4a8f
NS
173 fi
174}
175
9b752a6e
SB
176test -f "$GIT_DIR"/rebase-apply/applying &&
177 die 'It looks like git-am is in progress. Cannot rebase.'
178
1b1dce4b
JS
179is_interactive "$@" && exec git-rebase--interactive "$@"
180
9b752a6e
SB
181if test $# -eq 0
182then
183 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply || usage
184 test -d "$dotest" -o -f "$GIT_DIR"/rebase-apply/rebasing &&
185 die 'A rebase is in progress, try --continue, --skip or --abort.'
186 die "No arguments given and $GIT_DIR/rebase-apply already exists."
187fi
188
822f7c73 189while test $# != 0
e646c9c8
JH
190do
191 case "$1" in
c4427656
NS
192 --no-verify)
193 OK_TO_SKIP_PRE_REBASE=yes
194 ;;
031321c6 195 --continue)
51ef1daa 196 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
cd5320f2
SB
197 die "No rebase in progress?"
198
6848d58c 199 git diff-files --quiet --ignore-submodules || {
06aff47b 200 echo "You must edit all merge conflicts and then"
9b07873a 201 echo "mark them as resolved using git add"
031321c6 202 exit 1
06aff47b 203 }
58634dbf
EW
204 if test -d "$dotest"
205 then
889a50e9
JS
206 prev_head=$(cat "$dotest/prev_head")
207 end=$(cat "$dotest/end")
208 msgnum=$(cat "$dotest/msgnum")
209 onto=$(cat "$dotest/onto")
58634dbf
EW
210 continue_merge
211 while test "$msgnum" -le "$end"
212 do
213 call_merge "$msgnum"
214 continue_merge
215 done
216 finish_rb_merge
217 exit
218 fi
51ef1daa
JS
219 head_name=$(cat "$GIT_DIR"/rebase-apply/head-name) &&
220 onto=$(cat "$GIT_DIR"/rebase-apply/onto) &&
221 orig_head=$(cat "$GIT_DIR"/rebase-apply/orig-head) &&
3f735b66
JS
222 git am --resolved --3way --resolvemsg="$RESOLVEMSG" &&
223 move_to_original_branch
cc120056
SE
224 exit
225 ;;
226 --skip)
51ef1daa 227 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
cd5320f2
SB
228 die "No rebase in progress?"
229
fb6e4e1f 230 git reset --hard HEAD || exit $?
58634dbf
EW
231 if test -d "$dotest"
232 then
b4372ef1 233 git rerere clear
889a50e9
JS
234 prev_head=$(cat "$dotest/prev_head")
235 end=$(cat "$dotest/end")
236 msgnum=$(cat "$dotest/msgnum")
d5e673b6 237 msgnum=$(($msgnum + 1))
889a50e9 238 onto=$(cat "$dotest/onto")
d5e673b6
EW
239 while test "$msgnum" -le "$end"
240 do
241 call_merge "$msgnum"
242 continue_merge
243 done
244 finish_rb_merge
245 exit
58634dbf 246 fi
51ef1daa
JS
247 head_name=$(cat "$GIT_DIR"/rebase-apply/head-name) &&
248 onto=$(cat "$GIT_DIR"/rebase-apply/onto) &&
249 orig_head=$(cat "$GIT_DIR"/rebase-apply/orig-head) &&
6fd2f5e6
JS
250 git am -3 --skip --resolvemsg="$RESOLVEMSG" &&
251 move_to_original_branch
031321c6
SE
252 exit
253 ;;
254 --abort)
51ef1daa 255 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
cd5320f2
SB
256 die "No rebase in progress?"
257
b4372ef1 258 git rerere clear
58634dbf
EW
259 if test -d "$dotest"
260 then
6fd2f5e6 261 move_to_original_branch
cd5320f2 262 else
51ef1daa 263 dotest="$GIT_DIR"/rebase-apply
6fd2f5e6 264 move_to_original_branch
58634dbf 265 fi
97b88dd5 266 git reset --hard $(cat "$dotest/orig-head")
48411d22 267 rm -r "$dotest"
031321c6
SE
268 exit
269 ;;
e646c9c8
JH
270 --onto)
271 test 2 -le "$#" || usage
272 newbase="$2"
273 shift
274 ;;
58634dbf
EW
275 -M|-m|--m|--me|--mer|--merg|--merge)
276 do_merge=t
277 ;;
278 -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
279 --strateg=*|--strategy=*|\
280 -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
281 case "$#,$1" in
282 *,*=*)
8096fae7 283 strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
58634dbf
EW
284 1,*)
285 usage ;;
286 *)
287 strategy="$2"
288 shift ;;
289 esac
290 do_merge=t
291 ;;
a9c3821c
TAV
292 -n|--no-stat)
293 diffstat=
294 ;;
295 --stat)
296 diffstat=t
297 ;;
b758789c
RS
298 -v|--verbose)
299 verbose=t
a9c3821c 300 diffstat=t
b758789c 301 ;;
059f446d
BF
302 --whitespace=*)
303 git_am_opt="$git_am_opt $1"
b2f82e05
SR
304 case "$1" in
305 --whitespace=fix|--whitespace=strip)
306 force_rebase=t
307 ;;
308 esac
059f446d 309 ;;
570ccad3
MB
310 --committer-date-is-author-date|--ignore-date)
311 git_am_opt="$git_am_opt $1"
312 force_rebase=t
313 ;;
67dad687 314 -C*)
059f446d 315 git_am_opt="$git_am_opt $1"
67dad687 316 ;;
190f5323
TR
317 --root)
318 rebase_root=t
319 ;;
3f7d9928 320 -f|--f|--fo|--for|--forc|force|--force-r|--force-re|--force-reb|--force-reba|--force-rebas|--force-rebase)
b2f82e05
SR
321 force_rebase=t
322 ;;
e646c9c8
JH
323 -*)
324 usage
325 ;;
326 *)
327 break
328 ;;
329 esac
330 shift
331done
51b2ead0 332test $# -gt 2 && usage
2db8aaec 333
51ef1daa 334# Make sure we do not have $GIT_DIR/rebase-apply
58634dbf 335if test -z "$do_merge"
7f4bd5d8 336then
9b752a6e 337 if mkdir "$GIT_DIR"/rebase-apply 2>/dev/null
58634dbf 338 then
51ef1daa 339 rmdir "$GIT_DIR"/rebase-apply
58634dbf
EW
340 else
341 echo >&2 '
9b752a6e
SB
342It seems that I cannot create a rebase-apply directory, and
343I wonder if you are in the middle of patch application or another
51ef1daa
JS
344rebase. If that is not the case, please
345 rm -fr '"$GIT_DIR"'/rebase-apply
9b752a6e 346and run me again. I am stopping in case you still have something
51ef1daa 347valuable there.'
58634dbf
EW
348 exit 1
349 fi
350else
351 if test -d "$dotest"
352 then
28ed6e7b 353 die "previous rebase directory $dotest still exists." \
9b752a6e 354 'Try git rebase (--continue | --abort | --skip)'
58634dbf 355 fi
7f4bd5d8
JH
356fi
357
7f59dbbb 358# The tree must be really really clean.
07e62b73 359if ! git update-index --ignore-submodules --refresh; then
bc2bbc45 360 die "cannot rebase: you have unstaged changes"
07e62b73 361fi
6848d58c 362diff=$(git diff-index --cached --name-status -r --ignore-submodules HEAD --)
32d99544 363case "$diff" in
07e62b73
JK
364?*) echo >&2 "cannot rebase: your index contains uncommitted changes"
365 echo >&2 "$diff"
7f59dbbb
JH
366 exit 1
367 ;;
368esac
99a92f92 369
190f5323
TR
370if test -z "$rebase_root"
371then
372 # The upstream head must be given. Make sure it is valid.
373 upstream_name="$1"
374 shift
375 upstream=`git rev-parse --verify "${upstream_name}^0"` ||
376 die "invalid upstream $upstream_name"
377 unset root_flag
378 upstream_arg="$upstream_name"
379else
380 test -z "$newbase" && die "--root must be used with --onto"
381 unset upstream_name
382 unset upstream
383 root_flag="--root"
384 upstream_arg="$root_flag"
385fi
32d99544 386
a1bf91e0
JH
387# Make sure the branch to rebase onto is valid.
388onto_name=${newbase-"$upstream_name"}
5be60078 389onto=$(git rev-parse --verify "${onto_name}^0") || exit
a1bf91e0 390
9a111c91 391# If a hook exists, give it a chance to interrupt
190f5323 392run_pre_rebase_hook "$upstream_arg" "$@"
9a111c91 393
0cb06644
JH
394# If the branch to rebase is given, that is the branch we will rebase
395# $branch_name -- branch being rebased, or HEAD (already detached)
396# $orig_head -- commit object name of tip of the branch before rebasing
397# $head_name -- refs/heads/<that-branch> or "detached HEAD"
398switch_to=
59e6b23a 399case "$#" in
190f5323 4001)
0cb06644 401 # Is it "rebase other $branchname" or "rebase other $commit"?
190f5323
TR
402 branch_name="$1"
403 switch_to="$1"
0cb06644 404
190f5323
TR
405 if git show-ref --verify --quiet -- "refs/heads/$1" &&
406 branch=$(git rev-parse -q --verify "refs/heads/$1")
0cb06644 407 then
190f5323
TR
408 head_name="refs/heads/$1"
409 elif branch=$(git rev-parse -q --verify "$1")
0cb06644
JH
410 then
411 head_name="detached HEAD"
412 else
413 usage
414 fi
e646c9c8
JH
415 ;;
416*)
0cb06644 417 # Do not need to switch branches, we are already on it.
bcf31618
JH
418 if branch_name=`git symbolic-ref -q HEAD`
419 then
0cb06644 420 head_name=$branch_name
bcf31618
JH
421 branch_name=`expr "z$branch_name" : 'zrefs/heads/\(.*\)'`
422 else
0cb06644 423 head_name="detached HEAD"
bcf31618
JH
424 branch_name=HEAD ;# detached
425 fi
0cb06644 426 branch=$(git rev-parse --verify "${branch_name}^0") || exit
e646c9c8 427 ;;
59e6b23a 428esac
0cb06644 429orig_head=$branch
59e6b23a 430
190f5323
TR
431# Now we are rebasing commits $upstream..$branch (or with --root,
432# everything leading up to $branch) on top of $onto
e646c9c8 433
1308c17b
JS
434# Check if we are already based on $onto with linear history,
435# but this should be done only when upstream and onto are the same.
5be60078 436mb=$(git merge-base "$onto" "$branch")
1308c17b
JS
437if test "$upstream" = "$onto" && test "$mb" = "$onto" &&
438 # linear history?
bbf08124 439 ! (git rev-list --parents "$onto".."$branch" | grep " .* ") > /dev/null
7f4bd5d8 440then
b2f82e05
SR
441 if test -z "$force_rebase"
442 then
443 # Lazily switch to the target branch if needed...
444 test -z "$switch_to" || git checkout "$switch_to"
445 echo >&2 "Current branch $branch_name is up to date."
446 exit 0
447 else
448 echo "Current branch $branch_name is up to date, rebase forced."
449 fi
7f4bd5d8
JH
450fi
451
0cb06644 452# Detach HEAD and reset the tree
228e2eb6 453echo "First, rewinding head to replay your work on top of it..."
324c2c31 454git checkout -q "$onto^0" || die "could not detach HEAD"
22e40795 455git update-ref ORIG_HEAD $branch
32d99544 456
a9c3821c
TAV
457if test -n "$diffstat"
458then
459 if test -n "$verbose"
460 then
461 echo "Changes from $mb to $onto:"
462 fi
463 # We want color (if set), but no pager
464 GIT_PAGER='' git diff --stat --summary "$mb" "$onto"
465fi
466
e646c9c8 467# If the $onto is a proper descendant of the tip of the branch, then
32d99544 468# we just fast forwarded.
83c31614 469if test "$mb" = "$branch"
32d99544 470then
d587ed13 471 echo >&2 "Fast-forwarded $branch_name to $onto_name."
6fd2f5e6 472 move_to_original_branch
32d99544
LS
473 exit 0
474fi
475
190f5323
TR
476if test -n "$rebase_root"
477then
478 revisions="$onto..$orig_head"
479else
480 revisions="$upstream..$orig_head"
481fi
482
58634dbf
EW
483if test -z "$do_merge"
484then
0cb06644 485 git format-patch -k --stdout --full-index --ignore-if-in-upstream \
190f5323 486 $root_flag "$revisions" |
3041c324 487 git am $git_am_opt --rebasing --resolvemsg="$RESOLVEMSG" &&
6fd2f5e6
JS
488 move_to_original_branch
489 ret=$?
51ef1daa
JS
490 test 0 != $ret -a -d "$GIT_DIR"/rebase-apply &&
491 echo $head_name > "$GIT_DIR"/rebase-apply/head-name &&
492 echo $onto > "$GIT_DIR"/rebase-apply/onto &&
493 echo $orig_head > "$GIT_DIR"/rebase-apply/orig-head
6fd2f5e6 494 exit $ret
58634dbf
EW
495fi
496
497# start doing a rebase with git-merge
498# this is rename-aware if the recursive (default) strategy is used
499
500mkdir -p "$dotest"
501echo "$onto" > "$dotest/onto"
0bb733c9 502echo "$onto_name" > "$dotest/onto_name"
6fd2f5e6 503prev_head=$orig_head
58634dbf 504echo "$prev_head" > "$dotest/prev_head"
6fd2f5e6
JS
505echo "$orig_head" > "$dotest/orig-head"
506echo "$head_name" > "$dotest/head-name"
58634dbf
EW
507
508msgnum=0
190f5323 509for cmt in `git rev-list --reverse --no-merges "$revisions"`
58634dbf
EW
510do
511 msgnum=$(($msgnum + 1))
5887ac82 512 echo "$cmt" > "$dotest/cmt.$msgnum"
58634dbf
EW
513done
514
5887ac82
JH
515echo 1 >"$dotest/msgnum"
516echo $msgnum >"$dotest/end"
58634dbf
EW
517
518end=$msgnum
519msgnum=1
520
521while test "$msgnum" -le "$end"
522do
523 call_merge "$msgnum"
524 continue_merge
525done
cc120056 526
58634dbf 527finish_rb_merge